Bug 1462472 - Review Request: qotd - A simple and lightweight Quote of the Day daemon
Review Request: qotd - A simple and lightweight Quote of the Day daemon
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Sandro Mani
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-06-17 19:34 EDT by Ben Rosser
Modified: 2017-08-17 21:20 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-08-17 21:20:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
manisandro: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Ben Rosser 2017-06-17 19:34:37 EDT
Spec URL: https://tc01.fedorapeople.org/qotd/qotd.spec
SRPM URL: https://tc01.fedorapeople.org/qotd/qotd-0.11.0-1.fc25.src.rpm

Description: QOTD (quote of the day) is specified in RFC 865 as a way of broadcasting a quote to users. On both TCP and UDP, port 17 is officially reserved for this purpose. This program is meant to provide a simple QOTD daemon on IPv4 and IPv6 over TCP/IP.

Fedora Account System Username: tc01

There is only one rpmlint message:

$ rpmlint -i ../RPMS/x86_64/qotd-0.11.0-1.fc25.x86_64.rpm 
qotd.x86_64: E: missing-call-to-setgroups-before-setuid /usr/bin/qotdd
This executable is calling setuid and setgid without setgroups or initgroups.
There is a high probability this means it didn't relinquish all groups, and
this would be a potential security issue to be fixed. Seek POS36-C on the web
for details about the problem.

I've filed a ticket upstream about this here: https://github.com/ammongit/qotd/issues/11.
Comment 1 Sandro Mani 2017-07-04 05:10:41 EDT
Full review below. Only some small stuff:
- BR make
- comment why parallel build is disabled, or enable (could use %make_build)
- license GPLv2+
- could update to 0.11.3
- to clarify with upstream? qotd.x86_64: E: missing-call-to-setgroups-before-setuid /usr/bin/qotdd


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* GPL (v2 or later)", "GPL (v2 or later)",
     "Unknown or generated". 9 files have unknown license. Detailed output
     of licensecheck in /home/sandro/Desktop/1462472-qotd/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/systemd/system,
     /usr/lib/systemd
[?]: Package does not own files or directories owned by other packages.
[!]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[!]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: qotd-0.11.0-1.fc27.x86_64.rpm
          qotd-debuginfo-0.11.0-1.fc27.x86_64.rpm
          qotd-0.11.0-1.fc27.src.rpm
qotd.x86_64: E: missing-call-to-setgroups-before-setuid /usr/bin/qotdd
qotd.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
qotd.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
3 packages and 0 specfiles checked; 1 errors, 2 warnings.




Rpmlint (debuginfo)
-------------------
Checking: qotd-debuginfo-0.11.0-1.fc27.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
qotd.x86_64: E: missing-call-to-setgroups-before-setuid /usr/bin/qotdd
qotd.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
qotd.x86_64: W: hidden-file-or-dir /usr/lib/.build-id
2 packages and 0 specfiles checked; 1 errors, 2 warnings.



Requires
--------
qotd (rpmlib, GLIBC filtered):
    config(qotd)
    libc.so.6()(64bit)
    rtld(GNU_HASH)

qotd-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
qotd:
    config(qotd)
    qotd
    qotd(x86-64)

qotd-debuginfo:
    qotd-debuginfo
    qotd-debuginfo(x86-64)



Source checksums
----------------
https://gitlab.com/ammongit/qotd/repository/archive.tar.gz?ref=v0.11.0#/qotd-0.11.0.tar.gz :
  CHECKSUM(SHA256) this package     : 9afdaa71ab2e592ba7fbde0600fc4ced22a1e3b28c88c83d5861d67686c9eae2
  CHECKSUM(SHA256) upstream package : 9afdaa71ab2e592ba7fbde0600fc4ced22a1e3b28c88c83d5861d67686c9eae2


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1462472
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 2 Ben Rosser 2017-07-09 15:01:40 EDT
Spec URL: https://tc01.fedorapeople.org/qotd/qotd.spec
SRPM URL: https://tc01.fedorapeople.org/qotd/qotd-0.11.3-1.fc25.src.rpm

- Update to latest upstream release.
- Enable parallel build.
- Change license tag to correct GPLv2+.
- Add buildrequires on make.

I reported the setgroups issue upstream here; it's since been fixed in one of the point releases of 0.11. https://github.com/ammongit/qotd/issues/11
Comment 3 Sandro Mani 2017-07-09 15:25:34 EDT
All good, approved!
Comment 4 Gwyn Ciesla 2017-07-09 21:15:27 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/qotd
Comment 5 Fedora Update System 2017-07-09 22:00:58 EDT
qotd-0.11.3-1.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-8ae3c81d37
Comment 6 Fedora Update System 2017-07-09 22:29:09 EDT
qotd-0.11.3-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-2156b74af7
Comment 7 Fedora Update System 2017-07-12 01:27:58 EDT
qotd-0.11.3-1.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-fa23e4d91b
Comment 8 Fedora Update System 2017-07-12 04:36:17 EDT
qotd-0.11.3-1.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-8ae3c81d37
Comment 9 Fedora Update System 2017-07-12 05:24:07 EDT
qotd-0.11.3-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-2156b74af7
Comment 10 Fedora Update System 2017-07-20 11:52:49 EDT
qotd-0.11.3-1.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.
Comment 11 Fedora Update System 2017-07-20 16:53:16 EDT
qotd-0.11.3-1.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.
Comment 12 Fedora Update System 2017-07-20 21:41:40 EDT
qotd-0.11.3-2.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-4084c13468
Comment 13 Fedora Update System 2017-07-23 00:22:51 EDT
qotd-0.11.3-2.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-4084c13468
Comment 14 Fedora Update System 2017-08-17 21:20:50 EDT
qotd-0.11.3-2.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.